summaryrefslogtreecommitdiff
path: root/helpers/chroot_proc
diff options
context:
space:
mode:
authorDaniel Baumann <daniel@debian.org>2010-02-05 17:10:44 +0100
committerDaniel Baumann <daniel@debian.org>2011-03-09 19:17:04 +0100
commit3b80c5c5d9c9d2eec91910b70a120da5943c7fac (patch)
tree31b5fef2977e7fabe669077041c569169c788a95 /helpers/chroot_proc
parent59e9a93ad08c171fb0d22e965c56f91c5bd17615 (diff)
downloadlive-build-3b80c5c5d9c9d2eec91910b70a120da5943c7fac.zip
live-build-3b80c5c5d9c9d2eec91910b70a120da5943c7fac.tar.gz
Dropping lh_ prefix from internal helpers, this is not user visible.
Diffstat (limited to 'helpers/chroot_proc')
-rwxr-xr-xhelpers/chroot_proc96
1 files changed, 96 insertions, 0 deletions
diff --git a/helpers/chroot_proc b/helpers/chroot_proc
new file mode 100755
index 0000000..392fa5e
--- /dev/null
+++ b/helpers/chroot_proc
@@ -0,0 +1,96 @@
+#!/bin/sh
+
+# lh_chroot_proc(1) - mount /proc
+# Copyright (C) 2006-2009 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Including common functions
+. "${LH_BASE:-/usr/share/live-helper}"/live-helper.sh
+
+# Setting static variables
+DESCRIPTION="$(Echo 'mount /proc')"
+HELP=""
+USAGE="${PROGRAM} {install|remove} [--force]"
+
+Arguments "${@}"
+
+# Ensure that a system is built as root
+lh testroot
+
+# Reading configuration files
+Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
+Set_defaults
+
+# Requiring stage file
+Require_stagefile .stage/config .stage/bootstrap
+
+case "${1}" in
+ install)
+ Echo_message "Begin mounting /proc..."
+
+ # Checking stage file
+ Check_stagefile .stage/chroot_proc
+
+ # Checking lock file
+ Check_lockfile .lock
+
+ # Creating lock file
+ Create_lockfile .lock
+
+ if [ "${LH_USE_FAKEROOT}" != "true" ]
+ then
+ # Creating mountpoint
+ mkdir -p chroot/proc
+
+ # Mounting /proc
+ ${LH_ROOT_COMMAND} mount proc-live -t proc chroot/proc
+ else
+ rm -rf chroot/proc
+ ln -s /proc chroot/
+ fi
+
+ # Creating stage file
+ Create_stagefile .stage/chroot_proc
+ ;;
+
+ remove)
+ Echo_message "Begin unmounting /proc..."
+
+ # Checking lock file
+ Check_lockfile .lock
+
+ # Creating lock file
+ Create_lockfile .lock
+
+ if [ "${LH_USE_FAKEROOT}" != "true" ]
+ then
+ # Workaround binfmt-support /proc locking
+ if [ -e chroot/proc/sys/fs/binfmt_misc/status ]
+ then
+ ${LH_ROOT_COMMAND} umount chroot/proc/sys/fs/binfmt_misc
+ fi
+
+ # Unmounting /proc
+ #fuser -km chroot/proc
+ if [ -e chroot/proc/version ]
+ then
+ ${LH_ROOT_COMMAND} umount chroot/proc
+ fi
+ else
+ rm -rf chroot/proc
+ mkdir -p chroot/proc
+ fi
+
+ # Removing stage file
+ rm -f .stage/chroot_proc
+ ;;
+
+ *)
+ Usage
+ ;;
+esac